MoreParser Class Referencefinal

the main class to read a More file More...

`#include <MoreParser.hxx>`

Inheritance diagram for MoreParser:

## Public Member Functions

| MoreParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~MoreParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions

void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document
MWAWVec2f | getPageLeftTop () const
| returns the page left top point ( in inches)
void | newPage (int number)
| adds a new page
bool | getColor (int id, MWAWColor &col) const
| return the color which corresponds to an id (if possible)
bool | createZones ()
| finds the different objects zones
bool | readZonesList ()
| read the list of zones ( v2-3) : first 0x80 bytes
bool | readPrintInfo (MWAWEntry const &entry)
| read a PrintInfo zone ( first block )
bool | readDocumentInfo (MWAWEntry const &entry)
| read a docinfo zone ( second block )
bool | readSlideList (MWAWEntry const &entry)
| read the list of slide definitions
bool | readSlide (MWAWEntry const &entry)
| read a slide definitions
bool | readGraphic (MWAWEntry const &entry)
| read a graphic ( in a slide )
bool | readUnknown9 (MWAWEntry const &entry)
| read a unknown zone ( block 9 )
bool | readColors (long endPos)
| read a color zone ( beginning of block 9 )
bool | readPattern (long endPos, MoreStruct::Pattern &pattern)
| read a pattern ( some sub zone of block 9)
bool | readBackside (long endPos, std::string &extra)
| read a backside ( some sub zone of block 9)
bool | readFreePos (MWAWEntry const &entry)
| read the list of free file position
bool | readUnkn9Sub (long endPos)
| read the last subzone find in a block 9 ( unknown meaning)
bool | checkAndStore (MWAWEntry const &entry)
| check if the entry is valid, if so store it in the list of entry
bool | checkAndFindSize (MWAWEntry &entry)
| check if the entry is valid defined by the begin pos points to a zone: dataSz data
MWAWInputStreamPtr | rsrcInput ()
| return the input input
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes

std::shared_ptr< MoreParserInternal::State > | m_state
| the state
std::shared_ptr< MoreText > | m_textParser
| the text parser

## Friends

class | MoreParserInternal::SubDocument
class | MoreText

## Detailed Description

the main class to read a More file

## Constructor & Destructor Documentation

## MoreParser()

MoreParser::MoreParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ~MoreParser()

MoreParser::~MoreParser | ( |  | ) |

final

destructor

## Member Function Documentation

## checkAndFindSize()

bool MoreParser::checkAndFindSize | ( | MWAWEntry & | entry | ) |

protected

check if the entry is valid defined by the begin pos points to a zone: dataSz data

Referenced by MoreText, and readSlideList().

## checkAndStore()

bool MoreParser::checkAndStore | ( | MWAWEntry const & | entry | ) |

protected

check if the entry is valid, if so store it in the list of entry

Referenced by MoreText, and readZonesList().

## checkHeader()

bool MoreParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )

final virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by MoreText, and parse().

## createDocument()

void MoreParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by MoreText, and parse().

## createZones()

bool MoreParser::createZones | ( |  | ) |

protected

finds the different objects zones

Referenced by MoreText, and parse().

## getColor()

bool MoreParser::getColor | ( | int | id,
|  | MWAWColor & | col ) const

protected

return the color which corresponds to an id (if possible)

Referenced by MoreText.

## getPageLeftTop()

MWAWVec2f MoreParser::getPageLeftTop | ( |  | ) | const

protected

returns the page left top point ( in inches)

Referenced by MoreText.

## init()

void MoreParser::init | ( |  | ) |

protected

inits all internal variables

Referenced by MoreParser(), and MoreText.

## newPage()

void MoreParser::newPage | ( | int | number | ) |

protected

adds a new page

Referenced by MoreText.

## parse()

void MoreParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |

final virtual

virtual function used to parse the input

Implements MWAWTextParser.

Referenced by MoreText.

## readBackside()

bool MoreParser::readBackside | ( | long | endPos,
|  | std::string & | extra )

protected

read a backside ( some sub zone of block 9)

Referenced by MoreText, and readUnknown9().

## readColors()

bool MoreParser::readColors | ( | long | endPos | ) |

protected

read a color zone ( beginning of block 9 )

Referenced by MoreText, and readUnknown9().

## readDocumentInfo()

bool MoreParser::readDocumentInfo | ( | MWAWEntry const & | entry | ) |

protected

read a docinfo zone ( second block )

Referenced by createZones(), and MoreText.

## readFreePos()

bool MoreParser::readFreePos | ( | MWAWEntry const & | entry | ) |

protected

read the list of free file position

Referenced by createZones(), and MoreText.

## readGraphic()

bool MoreParser::readGraphic | ( | MWAWEntry const & | entry | ) |

protected

read a graphic ( in a slide )

Referenced by MoreText, and readSlide().

## readPattern()

bool MoreParser::readPattern | ( | long | endPos,
|  | MoreStruct::Pattern & | pattern )

protected

read a pattern ( some sub zone of block 9)

Referenced by MoreText, and readUnknown9().

## readPrintInfo()

bool MoreParser::readPrintInfo | ( | MWAWEntry const & | entry | ) |

protected

read a PrintInfo zone ( first block )

Referenced by createZones(), and MoreText.

## readSlide()

bool MoreParser::readSlide | ( | MWAWEntry const & | entry | ) |

protected

read a slide definitions

Referenced by MoreText, and readSlideList().

## readSlideList()

bool MoreParser::readSlideList | ( | MWAWEntry const & | entry | ) |

protected

read the list of slide definitions

Referenced by createZones(), and MoreText.

## readUnkn9Sub()

bool MoreParser::readUnkn9Sub | ( | long | endPos | ) |

protected

read the last subzone find in a block 9 ( unknown meaning)

Referenced by MoreText, and readUnknown9().

## readUnknown9()

bool MoreParser::readUnknown9 | ( | MWAWEntry const & | entry | ) |

protected

read a unknown zone ( block 9 )

Referenced by createZones(), and MoreText.

## readZonesList()

bool MoreParser::readZonesList | ( |  | ) |

protected

read the list of zones ( v2-3) : first 0x80 bytes

Referenced by createZones(), and MoreText.

## rsrcAscii()

libmwaw::DebugFile & MoreParser::rsrcAscii | ( |  | ) |

protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by MoreText.

## rsrcInput()

MWAWInputStreamPtr MoreParser::rsrcInput | ( |  | ) |

protected

return the input input

Referenced by MoreText.

## Friends And Related Symbol Documentation

## MoreParserInternal::SubDocument

friend class MoreParserInternal::SubDocument

friend

## MoreText

friend class MoreText

friend

Referenced by init(), and MoreText.

## Member Data Documentation

## m_state

std::shared_ptr<MoreParserInternal::State> MoreParser::m_state

protected

the state

Referenced by checkAndStore(), checkHeader(), createDocument(), createZones(), getColor(), init(), MoreParser(), newPage(), readDocumentInfo(), and readZonesList().

## m_textParser

std::shared_ptr<MoreText> MoreParser::m_textParser

protected

the text parser

Referenced by createDocument(), createZones(), init(), MoreParser(), parse(), and readSlide().

The documentation for this class was generated from the following files:

- MoreParser.hxx
- MoreParser.cxx